##############################################################################
#
# Copyright (c) 2002 Nik Kim <fafhrd@datacom.kz> All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

import Globals
from Globals import InitializeClass
from Acquisition import aq_base
from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import _getViewFor
from Products.CMFCore.DynamicType import DynamicType
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.Formulator.Field import ZMIField
from Products.Formulator.Errors import ValidationError

class CMFField(ZMIField, DynamicType):
    """ cmf formulator Field """

    meta_type = 'CMF Form Field'

    security = ClassSecurityInfo()

    security.declareProtected(View, 'Title')
    def Title(self):
        """ """
        return self.get_value('title')
    
    security.declareProtected(View, 'Description')
    def Description(self):
        """ """
        return self.get_value('description')

    security.declareProtected(View, 'Type')
    def Type(self):
        """ """
        return self.getPortalTypeName()

    security.declareProtected(ModifyPortalContent, 'manage_edit')
    def manage_edit(self, REQUEST):
	""" """
        try:
            # validate the form and get results
            result = self.form.validate(REQUEST)
	    self._edit(result)
	    qst='portal_status_message=%s+changed.'%self.portal_type

        except ValidationError, err:
            if REQUEST:
        	qst = "Error: %s - %s" % (err.field.get_value('title'),
					  err.error_text)
            else:
                raise

        if REQUEST is not None:
	    target_action = self.getTypeInfo().getActionById('edit')
	    REQUEST.RESPONSE.redirect( '%s/%s?%s' % (
		self.absolute_url(), target_action, qst) )
    
    def __call__(self):
        '''
        Invokes the default view.
        '''
        view = _getViewFor(self)
        if getattr(aq_base(view), 'isDocTemp', 0):
            return apply(view, (self, self.REQUEST))
        else:
            return view()

    index_html = None  # This special value informs ZPublisher to use __call__

    security.declareProtected(View, 'view')
    view = __call__

InitializeClass(CMFField)
