from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from CMFField import CMFField
from Products.Formulator.StandardFields import StringField, \
     PasswordField, EmailField, PatternField, CheckBoxField,\
     FloatField, IntegerField, TextAreaField, RawTextAreaField, \
     ListField, MultiListField, LinesField, FileField, LinkField,\
     DateTimeField, MultiCheckBoxField, RadioField

klasses = []
ftis  = []
factories = []

def register_field(klass, factory):
    global klasses, ftis, factories

    klasses.append(klass)
    factories.append(factory)
                   
    field_klass = klass.__bases__[1]
    klass_name  = field_klass.__name__

    fti = {'id'             : "Form %s"%klass_name,
           'meta_type'      : field_klass.meta_type,
           'description'    : "Form %s"%klass_name,
           'icon'           : "%s.gif"%klass_name,
           'product'        : 'CMFFormulator',
           'factory'        : factory.__name__,
           'immediate_view' : 'field_edit_form',
           'global_allow'   : 0,
           'actions'        :
           ( { 'id'         : 'view',
               'name'       : 'View',
               'action'     : 'field_view',
               'permissions': (View,),
               'category'   : 'object',
               },
             { 'id'         : 'edit',
               'name'       : 'Edit',
               'action'     : 'field_edit_form',
               'permissions': (ModifyPortalContent,),
               'category'   : 'object',
               },
             )
           }
    ftis.append(fti)


class CMFStringField(CMFField, StringField): pass
CMFStringField.meta_type = StringField.meta_type
def addCMFStringField(self,id,**kw): self._setObject(id, CMFStringField(id,**kw))
register_field(CMFStringField, addCMFStringField)

class CMFPasswordField(CMFField, PasswordField): pass
CMFPasswordField.meta_type = PasswordField.meta_type
def addCMFPasswordField(self,id,**kw): self._setObject(id, CMFPasswordField(id,**kw))
register_field(CMFPasswordField, addCMFPasswordField)

class CMFEmailField(CMFField, EmailField): pass
CMFEmailField.meta_type = EmailField.meta_type
def addCMFEmailField(self,id,**kw): self._setObject(id, CMFEmailField(id,**kw))
register_field(CMFEmailField, addCMFEmailField)

class CMFPatternField(CMFField, PatternField): pass
CMFPatternField.meta_type = PatternField.meta_type
def addCMFPatternField(self,id,**kw): self._setObject(id, CMFPatternField(id,**kw))
register_field(CMFPatternField, addCMFPatternField)

class CMFCheckBoxField(CMFField, CheckBoxField): pass
CMFCheckBoxField.meta_type = CheckBoxField.meta_type
def addCMFCheckBoxField(self,id,**kw): self._setObject(id, CMFCheckBoxField(id,**kw))
register_field(CMFCheckBoxField, addCMFCheckBoxField)

class CMFMultiCheckBoxField(CMFField, MultiCheckBoxField): pass
CMFMultiCheckBoxField.meta_type = MultiCheckBoxField.meta_type
def addCMFMultiCheckBoxField(self,id,**kw): self._setObject(id, CMFMultiCheckBoxField(id,**kw))
register_field(CMFMultiCheckBoxField, addCMFMultiCheckBoxField)

class CMFFloatField(CMFField, FloatField): pass
CMFFloatField.meta_type = FloatField.meta_type
def addCMFFloatField(self, id,**kw): self._setObject(id, CMFFloatField(id,**kw))
register_field(CMFFloatField, addCMFFloatField)

class CMFIntegerField(CMFField, IntegerField): pass
CMFIntegerField.meta_type = IntegerField.meta_type
def addCMFIntegerField(self, id,**kw): self._setObject(id, CMFIntegerField(id,**kw))
register_field(CMFIntegerField, addCMFIntegerField)

class CMFTextAreaField(CMFField, TextAreaField): pass
CMFTextAreaField.meta_type = TextAreaField.meta_type
def addCMFTextAreaField(self, id,**kw): self._setObject(id, CMFTextAreaField(id,**kw))
register_field(CMFTextAreaField, addCMFTextAreaField)

class CMFRawTextAreaField(CMFField, RawTextAreaField): pass
CMFRawTextAreaField.meta_type = RawTextAreaField.meta_type
def addCMFRawTextAreaField(self, id,**kw): self._setObject(id, CMFRawTextAreaField(id,**kw))
register_field(CMFRawTextAreaField, addCMFRawTextAreaField)

class CMFListField(CMFField, ListField): pass
CMFListField.meta_type = ListField.meta_type
def addCMFListField(self, id,**kw): self._setObject(id, CMFListField(id,**kw))
register_field(CMFListField, addCMFListField)

class CMFMultiListField(CMFField, MultiListField): pass
CMFMultiListField.meta_type = MultiListField.meta_type
def addCMFMultiListField(self, id,**kw): self._setObject(id, CMFMultiListField(id,**kw))
register_field(CMFMultiListField, addCMFMultiListField)

class CMFLinesField(CMFField, LinesField): pass
CMFLinesField.meta_type = LinesField.meta_type
def addCMFLinesField(self, id,**kw): self._setObject(id, CMFLinesField(id,**kw))
register_field(CMFLinesField, addCMFLinesField)

class CMFFileField(CMFField, FileField): pass
CMFFileField.meta_type = FileField.meta_type
def addCMFFileField(self, id,**kw): self._setObject(id, CMFFileField(id,**kw))
register_field(CMFFileField, addCMFFileField)

class CMFLinkField(CMFField, LinkField): pass
CMFLinkField.meta_type = LinkField.meta_type
def addCMFLinkField(self, id,**kw): self._setObject(id, CMFLinkField(id,**kw))
register_field(CMFLinkField, addCMFLinkField)

class CMFDateTimeField(CMFField, DateTimeField): pass
CMFDateTimeField.meta_type = DateTimeField.meta_type
def addCMFDateTimeField(self, id,**kw): self._setObject(id, CMFDateTimeField(id,**kw))
register_field(CMFDateTimeField, addCMFDateTimeField)

class CMFRadioField(CMFField, RadioField): pass
CMFRadioField.meta_type = RadioField.meta_type
def addCMFRadioField(self, id,**kw): self._setObject(id, CMFRadioField(id,**kw))
register_field(CMFRadioField, addCMFRadioField)
