# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@datacom.kz> 

"""Formulator Form object that come from the filesystem."""
__version__='$Revision: 0.3 $'[11:-2]

import Globals
from AccessControl import ClassSecurityInfo

from Products.CMFCore.CMFCorePermissions import ViewManagementScreens, View
from Products.CMFCore.FSObject import FSObject
from Products.CMFCore.DirectoryView \
     import registerFileExtension, registerMetaType, expandpath

from Products.Formulator.Form import ZMIForm
from Products.Formulator.XMLToForm import XMLToForm
from Products.Formulator.Validator import Validator

from Products.PythonScripts.PythonScript import PythonScript

class FSForm(FSObject, ZMIForm):
    """FSForm."""

    meta_type = 'Filesystem Formulator Form'

    manage_options = (
        ({'label':'Customize', 'action':'manage_main'},
         {'label':'Test', 'action':'formTest'},)
        )
    
    security = ClassSecurityInfo()
    security.declareObjectProtected(View)

    i18n_domain="portal_forms"
    show_buttons=1
    view_template = 'fs_form_view'

    def __init__(self, id, filepath, fullname=None, properties=None):
	ZMIForm.__init__(self, id, '')
        FSObject.__init__(self, id, filepath, fullname, properties)

    def _createZODBClone(self):
        return None

    def _readFile(self, reparse):
        f = open(expandpath(self._filepath), 'rb')
        # update the form with the xml data
        try:
            XMLToForm(f.read(), self)
        except:
            print 'Error file:', expandpath(self._filepath)
        f.close()

        # Experimental: edit_action
        #if form.has_key('edit_action'):
        #    obj = PythonScript('form_edit_action')
        #    obj.write(form['edit_action'])
        #    self._setObject('form_edit_action', obj)
            
    def index_html(self, REQUEST=None):
        """ """
        return getattr(self.aq_parent, self.view_template)(form=self)

    def Title(self):
        """ """
        return self.title

    def exec_action(self, context, **kwargs):
        """ """
        if hasattr(self, 'form_edit_action'):
            return self.form_edit_action(context=context, **kwargs)
        else:
            return getattr(context, self.action)(**kwargs)

Globals.InitializeClass(FSForm)

registerFileExtension('form', FSForm)
registerMetaType('FSForm', FSForm)

# fake validator
class FakeValidator (Validator):
    def validate(self, field, key, REQUEST):
        return string.strip(REQUEST.get(key, ""))
